#ifndef __RALINK_FLASH_H__
#define __RALINK_FLASH_H__

#if defined (CONFIG_RT2880_FLASH_32M)
    #define MTD_BOOT_PART_SIZE	    0x40000
    #define	MTD_CONFIG_PART_SIZE	0x20000
    #define	MTD_FACTORY_PART_SIZE	0x20000
#else
    #define MTD_BOOT_PART_SIZE	    0x30000
    #define	MTD_CONFIG_PART_SIZE	0x10000
    #define	MTD_FACTORY_PART_SIZE	0x10000
#endif

#ifdef CONFIG_RT2880_ROOTFS_IN_FLASH
    #ifdef CONFIG_ROOTFS_IN_FLASH_NO_PADDING
        #define CONFIG_MTD_KERNEL_PART_SIZ 0
    #endif

    #define MTD_ROOTFS_PART_SIZE	IMAGE1_SIZE - (MTD_BOOT_PART_SIZE + MTD_CONFIG_PART_SIZE + MTD_FACTORY_PART_SIZE + CONFIG_MTD_KERNEL_PART_SIZ)
    #define	MTD_KERN_PART_SIZE	    CONFIG_MTD_KERNEL_PART_SIZ
#else
    #define MTD_KERN_PART_SIZE	    IMAGE1_SIZE - (MTD_BOOT_PART_SIZE + MTD_CONFIG_PART_SIZE + MTD_FACTORY_PART_SIZE)
#endif

#ifdef CONFIG_DUAL_IMAGE
    #if defined (CONFIG_RT2880_FLASH_2M)
        #define IMAGE1_SIZE		0x100000
    #elif defined (CONFIG_RT2880_FLASH_4M)
        #define IMAGE1_SIZE		0x200000
    #elif defined (CONFIG_RT2880_FLASH_8M)
        #define IMAGE1_SIZE		0x400000
    #elif defined (CONFIG_RT2880_FLASH_16M)
        #define IMAGE1_SIZE		0x800000
    #elif defined (CONFIG_RT2880_FLASH_32M)
        #define IMAGE1_SIZE		0x1000000
    #endif

    #define MTD_KERN2_PART_SIZE	MTD_KERN_PART_SIZE
    #define MTD_KERN2_PART_OFFSET	IMAGE1_SIZE + (MTD_BOOT_PART_SIZE + MTD_CONFIG_PART_SIZE + MTD_FACTORY_PART_SIZE)

    #ifdef CONFIG_RT2880_ROOTFS_IN_FLASH
        #define MTD_ROOTFS2_PART_SIZE 	MTD_ROOTFS_PART_SIZE	
        #define MTD_ROOTFS2_PART_OFFSET (MTD_KERN2_PART_OFFSET + MTD_KERN2_PART_SIZE)
    #endif

#else // Non Dual Image
    #if defined (CONFIG_RT2880_FLASH_2M)
        #define IMAGE1_SIZE		0x200000
    #elif defined (CONFIG_RT2880_FLASH_4M)
        #define IMAGE1_SIZE		0x400000
    #elif defined (CONFIG_RT2880_FLASH_8M)
        #define IMAGE1_SIZE		0x800000
    #elif defined (CONFIG_RT2880_FLASH_16M)
        #define IMAGE1_SIZE		0x1000000
    #elif defined (CONFIG_RT2880_FLASH_32M)
        #define IMAGE1_SIZE		0x2000000
    #else
        #define IMAGE1_SIZE		CONFIG_MTD_PHYSMAP_LEN
    #endif
#endif

//Chad: Customize for AMIT
#if defined(CONFIG_CDE570AM_U_16M_FLASH_MAP) || \
    defined(CONFIG_BDW685NC_U01_16M_FLASH_MAP) || \
    defined(CONFIG_CIH573AM_U11_16M_FLASH_MAP) || \
    defined(CONFIG_CID688NC_16M_FLASH_MAP) || \
    defined(CONFIG_CDE685AM_U01_16M_FLASH_MAP) || \
    defined(CONFIG_CID561AM_16M_FLASH_MAP)
    #define FLASHMAP_WHOLE_SIZE    0x1000000
    #define FLASHMAP_WHOLE_OFFSET  0
    #define FLASHMAP_BOOT_SIZE     0x10000
    #define FLASHMAP_BOOT_OFFSET   0
    #define FLASHMAP_KERNEL_SIZE   CONFIG_MTD_KERNEL_PART_SIZ
    #define FLASHMAP_KERNEL_OFFSET 0x10000
    #define FLASHMAP_ROOTFS_SIZE   0xD90000
    #define FLASHMAP_ROOTFS_OFFSET 0x180000
    #define FLASHMAP_UI_SIZE       0xE0000
    #define FLASHMAP_UI_OFFSET     0xF10000
    #define FLASHMAP_CONFIG_SIZE   0x10000
    #define FLASHMAP_CONFIG_OFFSET 0xFF0000
#elif defined(CONFIG_CDW571AC_8M_FLASH_MAP) || \
    defined(CONFIG_CDE530AM_S_8M_FLASH_MAP) || \
    defined(CONFIG_CDE570AM_802_8M_FLASH_MAP) || \
    defined(CONFIG_CDE570AM_U02_8M_FLASH_MAP) || \
	defined(CONFIG_CDD531AM_8M_FLASH_MAP) || \
	defined(CONFIG_CDD531AC_8M_FLASH_MAP) || \
	defined(CONFIG_CDD571AM_8M_FLASH_MAP) || \
	defined(CONFIG_CDE665NC_8M_FLASH_MAP) || \
	defined(CONFIG_CDV561AM_U01_8M_FLASH_MAP)
    #define FLASHMAP_WHOLE_SIZE    0x800000
    #define FLASHMAP_WHOLE_OFFSET  0
    #define FLASHMAP_BOOT_SIZE     0x10000
    #define FLASHMAP_BOOT_OFFSET   0
    #define FLASHMAP_KERNEL_SIZE   CONFIG_MTD_KERNEL_PART_SIZ
    #define FLASHMAP_KERNEL_OFFSET 0x10000
    #define FLASHMAP_ROOTFS_SIZE   0x660000
    #define FLASHMAP_ROOTFS_OFFSET 0x130000
    #define FLASHMAP_UI_SIZE       0x60000
    #define FLASHMAP_UI_OFFSET     0x790000
    #define FLASHMAP_CONFIG_SIZE   0x10000
    #define FLASHMAP_CONFIG_OFFSET 0x7F0000
#elif defined(CONFIG_CTW583AM_8M_FLASH_MAP) || \
      defined(CONFIG_CDM532RP_8M_FLASH_MAP)
    #define FLASHMAP_WHOLE_SIZE    0x800000
    #define FLASHMAP_WHOLE_OFFSET  0
    #define FLASHMAP_BOOT_SIZE     0x10000
    #define FLASHMAP_BOOT_OFFSET   0
    #define FLASHMAP_KERNEL_SIZE   CONFIG_MTD_KERNEL_PART_SIZ
    #define FLASHMAP_KERNEL_OFFSET 0x10000
    #define FLASHMAP_ROOTFS_SIZE   0x5C0000
    #define FLASHMAP_ROOTFS_OFFSET 0x150000
    #define FLASHMAP_UI_SIZE       0xE0000
    #define FLASHMAP_UI_OFFSET     0x710000
    #define FLASHMAP_CONFIG_SIZE   0x10000
    #define FLASHMAP_CONFIG_OFFSET 0x7F0000 
#elif defined(CONFIG_CDS530AM_8M_FLASH_MAP)
    #define FLASHMAP_WHOLE_SIZE    0x800000
    #define FLASHMAP_WHOLE_OFFSET  0
    #define FLASHMAP_BOOT_SIZE     0x10000
    #define FLASHMAP_BOOT_OFFSET   0
    #define FLASHMAP_KERNEL_SIZE   CONFIG_MTD_KERNEL_PART_SIZ
    #define FLASHMAP_KERNEL_OFFSET 0x10000
    #define FLASHMAP_ROOTFS_SIZE   0x670000
    #define FLASHMAP_ROOTFS_OFFSET 0x110000
    #define FLASHMAP_UI_SIZE       0x70000
    #define FLASHMAP_UI_OFFSET     0x780000
    #define FLASHMAP_CONFIG_SIZE   0x10000
    #define FLASHMAP_CONFIG_OFFSET 0x7F0000 
#elif defined(CONFIG_CDM530AM_002_8M_FLASH_MAP)
    #define FLASHMAP_WHOLE_SIZE    0x800000
    #define FLASHMAP_WHOLE_OFFSET  0
    #define FLASHMAP_BOOT_SIZE     0x10000
    #define FLASHMAP_BOOT_OFFSET   0
    #define FLASHMAP_KERNEL_SIZE   CONFIG_MTD_KERNEL_PART_SIZ
    #define FLASHMAP_KERNEL_OFFSET 0x10000
    #define FLASHMAP_ROOTFS_SIZE   0x5C0000
    #define FLASHMAP_ROOTFS_OFFSET 0x150000
    #define FLASHMAP_UI_SIZE       0xDFFF0
    #define FLASHMAP_UI_OFFSET     0x710010
    #define FLASHMAP_CONFIG_SIZE   0x10000
    #define FLASHMAP_CONFIG_OFFSET 0x7F0000 
#elif defined(CONFIG_BDE571AM_002_8M_FLASH_MAP)
    #define FLASHMAP_WHOLE_SIZE    0x800000
    #define FLASHMAP_WHOLE_OFFSET  0
    #define FLASHMAP_BOOT_SIZE     0x10000
    #define FLASHMAP_BOOT_OFFSET   0
    #define FLASHMAP_KERNEL_SIZE   CONFIG_MTD_KERNEL_PART_SIZ
    #define FLASHMAP_KERNEL_OFFSET 0x10000
    #define FLASHMAP_ROOTFS_SIZE   0x5C0000
    #define FLASHMAP_ROOTFS_OFFSET 0x150000
    #define FLASHMAP_UI_SIZE       0xDFFF0
    #define FLASHMAP_UI_OFFSET     0x710010
    #define FLASHMAP_CONFIG_SIZE   0x10000
    #define FLASHMAP_CONFIG_OFFSET 0x7F0000 
#elif defined(CONFIG_CID561NC_8M_FLASH_MAP) || \
	  defined(CONFIG_CDD561NC_8M_FLASH_MAP)
    #define FLASHMAP_WHOLE_SIZE    0x800000
    #define FLASHMAP_WHOLE_OFFSET  0
    #define FLASHMAP_BOOT_SIZE     0x10000
    #define FLASHMAP_BOOT_OFFSET   0
    #define FLASHMAP_KERNEL_SIZE   CONFIG_MTD_KERNEL_PART_SIZ
    #define FLASHMAP_KERNEL_OFFSET 0x10000
    #define FLASHMAP_ROOTFS_SIZE   0x610000
    #define FLASHMAP_ROOTFS_OFFSET 0x150000
    #define FLASHMAP_UI_SIZE       0x90000
    #define FLASHMAP_UI_OFFSET     0x760000
    #define FLASHMAP_CONFIG_SIZE   0x10000
    #define FLASHMAP_CONFIG_OFFSET 0x7F0000 
#elif defined(CONFIG_CDD531AM_4M_FLASH_MAP)
    #define FLASHMAP_WHOLE_SIZE    0x400000
    #define FLASHMAP_WHOLE_OFFSET  0
    #define FLASHMAP_BOOT_SIZE     0x10000
    #define FLASHMAP_BOOT_OFFSET   0
    #define FLASHMAP_KERNEL_SIZE   CONFIG_MTD_KERNEL_PART_SIZ
    #define FLASHMAP_KERNEL_OFFSET 0x10000
    #define FLASHMAP_ROOTFS_SIZE   0x290000
    #define FLASHMAP_ROOTFS_OFFSET 0x110000
    #define FLASHMAP_UI_SIZE       0x4FFF0
    #define FLASHMAP_UI_OFFSET     0x3A0010
    #define FLASHMAP_CONFIG_SIZE   0x10000
    #define FLASHMAP_CONFIG_OFFSET 0x3F0000

//#elif defined(CONFIG_XXX_FLASH_MAP)      
// ...
// ... Defined your own Flash Map !!
// ...
//
#else //for 4M flash. 
    #define FLASHMAP_WHOLE_SIZE    0x400000
    #define FLASHMAP_WHOLE_OFFSET  0
    #define FLASHMAP_BOOT_SIZE     0x10000
    #define FLASHMAP_BOOT_OFFSET   0
    #define FLASHMAP_KERNEL_SIZE   CONFIG_MTD_KERNEL_PART_SIZ
    #define FLASHMAP_KERNEL_OFFSET 0x10000
    #define FLASHMAP_ROOTFS_SIZE   0x290000
    #define FLASHMAP_ROOTFS_OFFSET 0x110000
    #define FLASHMAP_UI_SIZE       0x50000
    #define FLASHMAP_UI_OFFSET     0x3A0000
    #define FLASHMAP_CONFIG_SIZE   0x10000
    #define FLASHMAP_CONFIG_OFFSET 0x3F0000  
#endif

#define BOOT_FROM_NOR	0
#define BOOT_FROM_NAND	2
#define BOOT_FROM_SPI	3

int ra_check_flash_type(void);

#endif //__RALINK_FLASH_H__
