/****************************************************************************
* File:         $Workfile$
* Revision:     $Revision: 1.1 $
* Date:         $Date: 2009-03-18 02:59:02 $
*
* Overview:     
* Functions:
*
* Author:       Ian Tsao
* 
* -- Metanoia Copyright Notice --
*
* (C) Copyright 2005 Metanoia, Inc. All rights reserved.
* 
* Metanoia reserves the right to change specifications without notice. 
* Copyright 2005 Metanoia, Inc. All rights reserved. Preliminary Data-Sheet 
* indicates this product is in design and the specification may change. 
* Electrical parametrics have not been analyzed and are not specified. Do not 
* use this data sheet as a design reference document. Please contact Metanoia 
* for a current data sheet that may be used as a design reference. All 
* contents of this document are protected by copyright law and may not be 
* reproduced without the express written consent of Metanoia, Inc. Metanoia, 
* the Metanoia logo, and combinations thereof are trademarks of Metanoia, Inc. 
* Other product names used in this publication are for identification purposes 
* only and may be trademarks or registered trademarks of their respective 
* companies. The contents of this document are provided in connection with 
* Metanoia, Inc. products. Metanoia, Inc. has made best efforts to ensure that 
* the information contained herein is accurate and reliable. However, Metanoia, 
* Inc. makes no warranties, express or implied, as to the accuracy or 
* completeness of the contents of this publication and is providing this 
* publication 'as is'. Metanoia, Inc. reserves the right to make changes to 
* specifications and product descriptions at any time without notice, and to 
* discontinue or make changes to its products at any time without notice. 
* Metanoia, Inc. does not assume any liability arising out of the application 
* or use of any product or circuit, and specifically disclaims any and all 
* liability, including without limitation special, consequential, or 
* incidental damages.
* 
****************************************************************************/
#ifndef HDLC_H
#define HDLC_H

#define HDLC_FCS_INIT		0xFFFF
#define HDLC_MAGIC_FCS		0xF0B8
#define	HDLC_CRC_FLAG		0x7E
#define	HDLC_LIMITER_FLAG	0x7E
#define	HDLC_CRC_ESC		0x7D
#define	HDLC_ESCAPE_FLAG	0x7D
#define	HDLC_CRC_INV		0x20
#define	HDLC_CRC_GENPOL		0x8408
#define	HDLC_EOC_INT_ADDR	0x11
#define	HDLC_EOC_EXT_ADDR	0xff
#define	HDLC_EOC_CTL		0x03

#define HDLC_FRAME_INIT 0
#define HDLC_FRAME_OPEN 1
#define HDLC_FRAME_ESC 2
#define HDLC_FRAME_END 3

typedef enum
{
	HDLC_INIT_ST,
	HDLC_IN_FRAME_ST,
	HDLC_END_FRAME_ST,
	HDLC_CRC_ESC_ST
}hdlc_state;

#include "port.h"

extern mt_uint32 ctrl_payload_frame(mt_uint8* CtrlFrame, mt_uint8 EocAddr, mt_uint8 EocCtrl, mt_uint32 FrameOffset, mt_uint8* InfoPayload,mt_uint32 InfoPayloadLen);
extern void ctrl_payload_deframe(mt_uint8* RxBuf,mt_uint16 RxLen, port_t *pport);

#endif // HDLC_H
