/****************************************************************************
* File:         $Workfile$
* Revision:     $Revision: 1.4 $
* Date:         $Date: 2009-06-04 07:19:55 $
*
* Overview:     
* Functions:
*
* Author:       Ian Tsao
* 
* -- Metanoia Copyright Notice --
*
* (C) Copyright 2005 Metanoia, Inc. All rights reserved.
* 
* Metanoia reserves the right to change specifications without notice. 
* Copyright 2005 Metanoia, Inc. All rights reserved. Preliminary Data-Sheet 
* indicates this product is in design and the specification may change. 
* Electrical parametrics have not been analyzed and are not specified. Do not 
* use this data sheet as a design reference document. Please contact Metanoia 
* for a current data sheet that may be used as a design reference. All 
* contents of this document are protected by copyright law and may not be 
* reproduced without the express written consent of Metanoia, Inc. Metanoia, 
* the Metanoia logo, and combinations thereof are trademarks of Metanoia, Inc. 
* Other product names used in this publication are for identification purposes 
* only and may be trademarks or registered trademarks of their respective 
* companies. The contents of this document are provided in connection with 
* Metanoia, Inc. products. Metanoia, Inc. has made best efforts to ensure that 
* the information contained herein is accurate and reliable. However, Metanoia, 
* Inc. makes no warranties, express or implied, as to the accuracy or 
* completeness of the contents of this publication and is providing this 
* publication 'as is'. Metanoia, Inc. reserves the right to make changes to 
* specifications and product descriptions at any time without notice, and to 
* discontinue or make changes to its products at any time without notice. 
* Metanoia, Inc. does not assume any liability arising out of the application 
* or use of any product or circuit, and specifically disclaims any and all 
* liability, including without limitation special, consequential, or 
* incidental damages.
* 
****************************************************************************/
#ifndef _MTERROR_H_
#define _MTERROR_H_
#define MT_OK 0

enum {
	/* no error */
	DSL_ERR_OK = 0,

	// l2 error
	MT_NO_SUCH_CHIP,
	MT_FW_NOT_SET_UP,
	MT_NO_CODE_TO_LOAD,
	MT_FRAME_TOO_LONG,
	MT_NO_SUCH_PORT,
	MT_SOME_CHIPS_FAILED,
	MT_CHIP_FAILED_TO_RESPOND,
	/* general error */
	DSL_ERR_NOTOK = 100,
	DSL_ERR_NODATA,
	DSL_ERR_NOGROUP,
	DSL_ERR_NOTABLE,
	DSL_ERR_NOPARAM,
	DSL_ERR_NOINDEX,
	DSL_ERR_NOINTERVAL, // no this interval at this time.
	DSL_ERR_NOCHIP,
	DSL_ERR_NOCMD,
	DSL_ERR_EXITCLI,
	/* check error */
	DSL_ERR_NOPASS,
	/* MIB2 check error */
	DSL_ERR_BINDRVNOTLOAD,
	DSL_ERR_BINDRVSIGNATURE,
	DSL_ERR_BINDRVCHKSUM,
	DSL_ERR_REVISION,
	DSL_ERR_ENDMARK,
	DSL_ERR_OIDTOOLONG,
	DSL_ERR_NOSUCHMIB,
	DSL_ERR_DATASIZE,
	DSL_ERR_ALIGNMENT,
	/* some type error */
	DSL_ERR_MISC = 200,
	/* TR069 fault codes*/
	TR069_ERR_METHOD = 9000,
	TR069_ERR_INTERNAL = 9002,
	TR069_ERR_ARGUMENTS = 9003,
	TR069_ERR_PARAMETER_NAME = 9005,
	TR069_ERR_PARAMETER_TYPE = 9006,
	TR069_ERR_PARAMETER_VALUE = 9007
};

#endif	//_MTERROR_H_
