/****************************************************************************
* File:         $Workfile$
* Revision:     $Revision: 1.1 $
* Date:         $Date: 2009-03-18 02:59:02 $
*
* Overview:     
* Functions:
*
* Author:       Ian Tsao
* 
* -- Metanoia Copyright Notice --
*
* (C) Copyright 2005 Metanoia, Inc. All rights reserved.
* 
* Metanoia reserves the right to change specifications without notice. 
* Copyright 2005 Metanoia, Inc. All rights reserved. Preliminary Data-Sheet 
* indicates this product is in design and the specification may change. 
* Electrical parametrics have not been analyzed and are not specified. Do not 
* use this data sheet as a design reference document. Please contact Metanoia 
* for a current data sheet that may be used as a design reference. All 
* contents of this document are protected by copyright law and may not be 
* reproduced without the express written consent of Metanoia, Inc. Metanoia, 
* the Metanoia logo, and combinations thereof are trademarks of Metanoia, Inc. 
* Other product names used in this publication are for identification purposes 
* only and may be trademarks or registered trademarks of their respective 
* companies. The contents of this document are provided in connection with 
* Metanoia, Inc. products. Metanoia, Inc. has made best efforts to ensure that 
* the information contained herein is accurate and reliable. However, Metanoia, 
* Inc. makes no warranties, express or implied, as to the accuracy or 
* completeness of the contents of this publication and is providing this 
* publication 'as is'. Metanoia, Inc. reserves the right to make changes to 
* specifications and product descriptions at any time without notice, and to 
* discontinue or make changes to its products at any time without notice. 
* Metanoia, Inc. does not assume any liability arising out of the application 
* or use of any product or circuit, and specifically disclaims any and all 
* liability, including without limitation special, consequential, or 
* incidental damages.
* 
****************************************************************************/
#include "dsll2.h"
/*#include "mttypes.h"
#include "mtfirmware.h"*/


#ifdef XENOS
mt_uint8 code0[] = 
{
	/*
	0x00, 0x00, 0x00, 0x00, 0x00, 0x02,
	0x0a, 0xf0, 0x80, 0x00, 0x00, 0x00,
	0xc0, 0x00, 0x00, 0x00, 0x00, 0x00
*/
#include "firmware_ot.h"
};

mt_uint8 code1[] = 
{
	/*
	0x00, 0x00, 0x00, 0x00, 0x00, 0x02,
	0x0a, 0xf0, 0x80, 0x00, 0x00, 0x00,
	0xc0, 0x00, 0x00, 0x00, 0x00, 0x00
*/
#include "firmware_rt.h"
};
#endif
#ifdef HOPE
mt_uint8 code0[] = 
{
	/*
	0x00, 0x00, 0x00, 0x00, 0x00, 0x02,
	0x0a, 0xf0, 0x80, 0x00, 0x00, 0x00,
	0xc0, 0x00, 0x00, 0x00, 0x00, 0x00
*/
#include "firmware_ot.h"
};

mt_uint8 code1[] = 
{
	/*
	0x00, 0x00, 0x00, 0x00, 0x00, 0x02,
	0x0a, 0xf0, 0x80, 0x00, 0x00, 0x00,
	0xc0, 0x00, 0x00, 0x00, 0x00, 0x00
*/
#include "firmware_rt.h"
};
#endif
#ifdef BOARD_A5
mt_uint8 code0[] = 
{
	/*
	0x00, 0x00, 0x00, 0x00, 0x00, 0x02,
	0x0a, 0xf0, 0x80, 0x00, 0x00, 0x00,
	0xc0, 0x00, 0x00, 0x00, 0x00, 0x00
*/
#include "firmware_ot.h"
};

mt_uint8 code1[] = 
{
	/*
	0x00, 0x00, 0x00, 0x00, 0x00, 0x02,
	0x0a, 0xf0, 0x80, 0x00, 0x00, 0x00,
	0xc0, 0x00, 0x00, 0x00, 0x00, 0x00
*/
#include "firmware_rt.h"
};
#endif
#ifdef AWARD
mt_uint8 code0[] = 
{
	/*
	0x00, 0x00, 0x00, 0x00, 0x00, 0x02,
	0x0a, 0xf0, 0x80, 0x00, 0x00, 0x00,
	0xc0, 0x00, 0x00, 0x00, 0x00, 0x00
*/
#include "firmware_ot.h"
};

mt_uint8 code1[] = 
{
	/*
	0x00, 0x00, 0x00, 0x00, 0x00, 0x02,
	0x0a, 0xf0, 0x80, 0x00, 0x00, 0x00,
	0xc0, 0x00, 0x00, 0x00, 0x00, 0x00
*/
#include "firmware_rt.h"
};
#endif


struct
{
	mt_uint8 *code;
	mt_uint8 desc[16];
} fw_table[] = 
{
#ifdef XENOS
	{
		code0,
		"ot"
	},
	{
		code1,
		"rt"
	},
#endif
#ifdef HOPE
	{
		code0,
		"ot"
	},
	{
		code1,
		"rt"
	},
#endif
#ifdef BOARD_A5
	{
		code0,
		"ot"
	},
	{
		code1,
		"rt"
	},
#endif
#ifdef AWARD
	{
		code0,
		"ot"
	},
	{
		code1,
		"rt"
	},
#endif
	{
		NULL,
		""
	},
	{
		NULL,
		""
	},
	{
		NULL,
		""
	},
	{
		NULL,
		""
	},
	{
		NULL,
		""
	}
};

fw_t	gtx_fw[] = 
{
#ifdef XENOS
	{ code0, sizeof(code0), "ot",MAX_PORTS
	},
	{ code1, sizeof(code1), "rt",MAX_PORTS
	}
#endif
#ifdef HOPE
	{ code0, sizeof(code0), "ot",MAX_PORTS
	},
	{ code1, sizeof(code1), "rt",MAX_PORTS
	}
#endif
#ifdef BOARD_A5
	{ code0, sizeof(code0), "ot",MAX_PORTS
	},
	{ code1, sizeof(code1), "rt",MAX_PORTS
	}
#endif
#ifdef AWARD
	{ code0, sizeof(code0), "ot",MAX_PORTS
	},
	{ code1, sizeof(code1), "rt",MAX_PORTS
	}
#endif
};

mt_uint8 *get_fw_desc(mt_uint32 firmwareID)
{
	return fw_table[firmwareID].desc;
}

void load_firmware(fw_t **pfw)
{
	*pfw = gtx_fw;
}
